
#install.packages("rms") 
#install.packages("foreign") 
#install.packages("survival") 

setwd("C:\\Bioinformatics analysis\\Metabolite gene prognosis\\Colorectal Cancer\\21-1.C-index")

library(rms)
library(foreign)
library(survival)

seer<-read.table("seer.txt",header=T,sep="\t")


seer$age<-factor(seer$age,labels=c("<50","50-59","60-69","70-79",">=80"))
seer$sex<-factor(seer$sex,labels=c("Female","Male"))
seer$stage<-factor(seer$stage,labels=c("stage I","stage II","stage III","stage IV"))
seer$stage_T<-factor(seer$stage_T,labels=c("T1","T2","T3","T4"))
seer$stage_N<-factor(seer$stage_N,labels=c("N0","N1","N2"))

ddist <- datadist(seer)
options(datadist='ddist')


fmla1 <- as.formula(Surv(survival_time,status) ~ age + sex + stage + stage_T + stage_N)
cox2 <- cph(fmla1,data=seer)
#C-index
coxpe <- predict(cox2)
c_index=1-rcorr.cens(coxpe,Surv(seer$survival_time,seer$status))
c_index

