#install.packages('GOplot')

setwd("C:\\Bioinformatics analysis\\GO\\all")
library(GOplot)
david=read.table("david.txt",header=T,sep="\t",check.names=F,stringsAsFactors = F)
genelist=read.table("gene.txt",header=T,sep="\t",check.names=F,stringsAsFactors = F)
circ <- circle_dat(david, genelist)

pdf("GO1.pdf")
GOBar(circ)
dev.off()

pdf("GO2.pdf")
GOBar(circ, display = 'multiple')
dev.off()

pdf("GO3.pdf")
GOBar(circ, display = 'multiple', title = 'Z-score coloured barplot', zsc.col = c('green', 'blue', 'red'))
dev.off()

pdf("GO4.pdf",26,18)
GOBubble(circ,labels =1)
dev.off()

pdf("GO5.pdf",10,8)
GOCircle(circ, nsub = 8)
dev.off()


chord <- chord_dat(circ,genelist,david$Term)
pdf("GO6.pdf",12,12)
GOChord(chord, space = 0.01, gene.order = 'logFC',gene.space = 0.25, gene.size =6)
dev.off()

pdf("GO7.pdf",12,10)
GOCluster(circ, david$Term, clust.by = 'logFC', term.width = 2)
dev.off()



