

#install.packages("survival")
#install.packages("survminer")

library(survival)
library("survminer")
setwd("C:\\Bioinformatics analysis\\Metabolite gene prognosis\\Colorectal Cancer\\16.survival")              #ùĿ¼

bioSurvival=function(inputFile=null,outFile=null){
		rt=read.table(inputFile,header=T,sep="\t")                   #ȡļ
		#Ƚϸߵͷ죬õpֵ
		diff=survdiff(Surv(futime, fustat) ~risk,data = rt)
		pValue=1-pchisq(diff$chisq,df=1)
		pValue=signif(pValue,4)
		pValue=format(pValue, scientific = TRUE)
		fit <- survfit(Surv(futime, fustat) ~ risk, data = rt)
		
		#
		surPlot=ggsurvplot(fit, 
		           data=rt,
		           conf.int=TRUE,
		           pval=paste0("p=",pValue),
		           pval.size=4,
		           risk.table=TRUE,
		           legend.labs=c("High risk", "Low risk"),
		           legend.title="Risk",
		           xlab="Time(years)",
		           break.time.by = 1,
		           risk.table.title="",
		           palette=c("red", "blue"),
		           risk.table.height=.25)
		pdf(file=outFile,onefile = FALSE,width = 6.5,height =5.5)
		print(surPlot)
		dev.off()
}
bioSurvival(inputFile="tcgaRisk.txt",outFile="tcgaRisk.pdf")
bioSurvival(inputFile="geoRisk.txt",outFile="geoRisk.pdf")

